function AlternativeSkirmish:StartActivity()
	print("START! -- ExtendedAlternativeSkirmish:StartActivity()!");
	dofile ("Extended Alternative Skirmish.rte/Scripts/CF_ConfigLibrary.lua");
	dofile ("Extended Alternative Skirmish.rte/Scripts/CF_MissionLibrary.lua");
	
	CF_InitFactions();

	self.playertally = 0;
	self.playerlist = {};
	self.currentenemies = 0;

	self.timeElapsed = 0;
	self.TechElapsed = 0;
	self.StopSending = 5;
	self.Specialtime = 35;
	self.SpecialStage = 0;
	self.SpecialStageRepeat = 0;

	self.wavewaitTimer = Timer();
	
	self.DoneEditing = false


	self.braindead = {}
	self.BrainDropDuration = {}
	self.TempBrain = {}
	self.Escape = false

----------------------------------------

	self.longestWaveDelay = 40000; -- Wave delay on lowest difficulty
	self.shortestWaveDelay = 28500; -- Wave delay on highest difficulty
	self.MaxWaveDelay = 0
	self.Diff = 0
	-- All delays in between are calculated with MATH

	self.maxDeliveryLoad = 2; -- Maximum number of units per delivery
	self.minDeliveryLoad = 1; -- Minimum number of units per delivery

	self.chanceOfCrab = 0.05; -- Chance of getting an ACrab. If you don't get a crab, an AHuman is delivered
	self.chanceOfRocket = 0.0; -- Chance of getting a rocket. If you don't get a rocket, a dropship comes

	self.PrimaryWeaponList = {"Sniper Rifle", "Nailer Cannon", "Destroyer Cannon", "Compact Assault Rifle", "Assault Rifle"};
	self.ShortRangePrimaryWeaponList = { "Blaster", "Nailer Cannon", "Destroyer Cannon", "Compact Assault Rifle", "Flamer", "Shotgun"};
	self.AdvancedPrimaryWeaponList = { "Sniper Rifle", "Nailer Cannon", "Assault Rifle", "Heavy Sniper Rifle", "Gatling Gun", "Flak Cannon", "Missile Launcher" , "RPG-7" };
	self.AdvancedShortRangePrimaryWeaponList = { "Impulse Cannon", "Nailer Cannon", "Assault Rifle", "Gatling Gun", "Napalm Flamer", "Auto Shotgun"};
	self.SecondaryWeaponList = { "Nailgun", "Rail Pistol", "Pistol", "Auto Pistol", "Heavy Pistol", "Uzi", "Shortgun", "Desert Eagle", "Glock" };
	self.DiggerList = { "Light Digger", "Medium Digger", "Heavy Digger", "Pulse Digger", "Turbo Digger" };
	self.BombList = { "Pineapple Grenade", "Grenade" };
	self.ShieldList = { "Riot Shield" };

	self.SimpleBodyList = { "Mia", "Dafred", "Dimitri", "Gordon", "Brutus", "Sandra"};
	self.BodyList = { "Soldier Heavy", "Soldier Light"};
	self.AdvancedBodyList = { "Soldier Heavy", "Browncoat Light", "Browncoat Heavy" };
	self.CrabList = { "Dreadnought" };

	self.DropShipList = { "Drop Ship", "Drop Ship MK1" };
	self.RocketList = { "Rocket MK1", "Rocket MK2" };
	self.PodList = { "Drop Crate" };

----------------------------------------

	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self:PlayerActive(player) and self:PlayerHuman(player) then
			self.braindead[player] = false
			self.BrainDropDuration[player] = 0
			self.playerlist[player + 1] = true;
			self.playertally = self.playertally + 1;
			-- Check if we already have a brain assigned
			if not self:GetPlayerBrain(player) then
				local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
				-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
				if not foundBrain then
					self.ActivityState = Activity.EDITING;
					AudioMan:ClearMusicQueue();
					AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
				else
					-- Set the found brain to be the selected actor at start
					self:SetPlayerBrain(foundBrain, player);
					self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
					self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
					-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
					self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				end
			end
		end
	end

	self.ESpawnTimer = Timer();
	--self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	--self.EnemyLZ = SceneMan.Scene:GetArea("LZ Team 2");
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self:SetTeamFunds(7500, Activity.TEAM_1);
		self:SetTeamFunds(7500, Activity.TEAM_2);
		self:SetTeamFunds(7500, Activity.TEAM_3);
		self:SetTeamFunds(7500, Activity.TEAM_4);
		self.wavewaittime = self.longestWaveDelay;
		self.MaxWaveDelay = self.wavewaittime --We will remember the longest wave delay for future purposes
		self.Diff = 0.5
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self:SetTeamFunds(6000, Activity.TEAM_1);
		self:SetTeamFunds(6000, Activity.TEAM_2);
		self:SetTeamFunds(6000, Activity.TEAM_3);
		self:SetTeamFunds(6000, Activity.TEAM_4);
		self.wavewaittime = ((4/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.MaxWaveDelay = self.wavewaittime
		self.Diff = 0.7
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self:SetTeamFunds(4500, Activity.TEAM_1);
		self:SetTeamFunds(4500, Activity.TEAM_2);
		self:SetTeamFunds(4500, Activity.TEAM_3);
		self:SetTeamFunds(4500, Activity.TEAM_4);
		self.wavewaittime = ((3/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.MaxWaveDelay = self.wavewaittime
		self.Diff = 1
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self:SetTeamFunds(3000, Activity.TEAM_1);
		self:SetTeamFunds(3000, Activity.TEAM_2);
		self:SetTeamFunds(3000, Activity.TEAM_3);
		self:SetTeamFunds(3000, Activity.TEAM_4);
		self.wavewaittime = ((2/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.MaxWaveDelay = self.wavewaittime
		self.Diff = 1.8
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self:SetTeamFunds(2000, Activity.TEAM_1);
		self:SetTeamFunds(2000, Activity.TEAM_2);
		self:SetTeamFunds(2000, Activity.TEAM_3);
		self:SetTeamFunds(2000, Activity.TEAM_4);
		self.wavewaittime = ((1/5)*(self.longestWaveDelay - self.shortestWaveDelay)) + self.shortestWaveDelay;
		self.MaxWaveDelay = self.wavewaittime
		self.Diff = 2.8
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self:SetTeamFunds(1500, Activity.TEAM_1);
		self:SetTeamFunds(1500, Activity.TEAM_2);
		self:SetTeamFunds(1500, Activity.TEAM_3);
		self:SetTeamFunds(1500, Activity.TEAM_4);
		self.wavewaittime = self.shortestWaveDelay;
		self.MaxWaveDelay = self.wavewaittime
		self.Diff = 5
	end

	print(self.wavewaittime);

	self.StartTimer = Timer();
	
	self.PlayerBrainPos = {};
end

function AlternativeSkirmish:PauseActivity(pause)
		print("PAUSE! -- ExtendedAlternativeSkirmish:PauseActivity()!");
end

function AlternativeSkirmish:EndActivity()
		print("END! -- ExtendedAlternativeSkirmish:EndActivity()!");
		
end

function AlternativeSkirmish:UpdateActivity()

--Used for locating average point of brains for AI purposes and creating a lz for them
	local braincount = 0;
	local brainPositionX={};
	local brainPositionX2=0;

	local EnemySpawnX1 = 0;
	local EnemySpawnX2 = 0;

--Used for making lz for player controlled teams
	local Teambraincount = {};
	local i = 0
	while i <= 5 do
		Teambraincount[i] = 0
		i = i + 1
	end
	local TeamPositionX={};
	local i = 0
	while i <= 5 do
		TeamPositionX[i]={};
		local j = 0
		while j <= 5 do
			TeamPositionX[i][j]=0;
			j = j + 1
		end
		i = i + 1
	end
	local TeamPositionX2={};
	local i = 0
	while i <= 5 do
		TeamPositionX2[i] = 0
		i = i + 1
	end

	local TeamSpawnX1 = {};
	local i = 0
	while i <= 5 do
		TeamSpawnX1[i] = 0
		i = i + 1
	end
	local TeamSpawnX2 = {};
	local i = 0
	while i <= 5 do
		TeamSpawnX2[i] = 0
		i = i + 1
	end
	
	if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then
	--Time Elapsed
		if self.Escape then
			self.wavewaittime = 5000/(self.Diff^0.5) + ((self.wavewaittime - 5000/(self.Diff^0.5)) * (1/(1.00004 + self.timeElapsed/20000)))
			self.TechElapsed = self.TechElapsed + 0.0025 + (self.timeElapsed * 0.0002 * (self.Diff^0.5))
		else
			self.wavewaittime = 12000/self.Diff + ((self.wavewaittime - 12000/self.Diff) * (1/(1.00004 + self.timeElapsed/200000)))
			self.TechElapsed = self.TechElapsed + 0.0025 + (self.timeElapsed * 0.00005 * self.Diff)
		end
		self.timeElapsed = self.timeElapsed + 0.01
		self.StopSending = self.StopSending - 0.01
		if startedMusic == nil then
			startedMusic = true;
			AudioMan:ClearMusicQueue();
			AudioMan:PlayMusic("Base.rte/Music/Watts/Last Man.ogg", -1, -1);
		end
	
		-- Clear all objective markers, they get re-added each frame
		self:ClearObjectivePoints();

		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				self.BrainDropDuration[player] = self.BrainDropDuration[player] - 1
				local team = self:GetTeamOfPlayer(player);
				if self.BrainDropDuration[player] == 0 then
					self.braindead[player] = false
					local actor = nil;
					actor = CreateAHuman("Brain Robot");
					actor.Team = team;
					actor.AIMode = Actor.AIMODE_SENTRY;
		
					local ship = nil;
					ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
					ship:AddInventoryItem(actor);
					ship.Team = team;
					ship.Pos = self.TempBrain[player].Pos;
					MovableMan:AddActor(ship);
					self:SetPlayerBrain(ship,player);
		
					self:SwitchToActor(ship, player, team)
					self.TempBrain[player].ToDelete = true
				end
				if not self.StartTimer:IsPastSimMS(3000) then
					FrameMan:SetScreenText("Survive against the enemy attacks!", player, 333, 5000, true);
				end
				if self.timeElapsed >= self.Specialtime - 2.5 and self.timeElapsed < self.Specialtime then
					if self.SpecialStage == 0 then
						FrameMan:SetScreenText("Powerful enemies incoming!!!", player, 333, 5000, true);
					end
					if self.SpecialStage == 4 then
						FrameMan:SetScreenText("Quads incoming!!!", player, 333, 5000, true);
					end
					if self.SpecialStage == 7  then
						FrameMan:SetScreenText("Coalition assault troops incoming!!!", player, 333, 5000, true);
					end
					if self.SpecialStage == 15 then
						FrameMan:SetScreenText("The enemies are too overwhelming! You have to escape!", player, 333, 5000, true);
					end
					if self.SpecialStage == 16 then
						FrameMan:SetScreenText("Detaching Brain Now", player, 333, 5000, true);
					end
				end
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) or not self:GetPlayerBrain(player):HasObjectInGroup("Brains") then
					self:SetPlayerBrain(nil, player)
					-- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
					local newBrain = MovableMan:GetUnassignedBrain(team)
					-- Found new brain actor, assign it and keep on truckin'
					if not self.braindead[player] then
						if newBrain then
							self:SetPlayerBrain(newBrain, player)
							if MovableMan:IsActor(newBrain) then
								self:SwitchToActor(newBrain, player, team)
							end
						else
							self.braindead[player] = true
							self:SetPlayerBrain(nil, player);
							self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
							FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false);
							if self.playerlist[player + 1] == true then
								self.playerlist[player + 1] = false;
								self.playertally = self.playertally - 1;
							end
						end
					end
				else
					local brain = self:GetPlayerBrain(player)
		
					--AI lz stuff
					braincount = braincount + 1;
					brainPositionX[braincount] = brain.Pos.X;

					--Team lz stuff
					Teambraincount[team] = Teambraincount[team] + 1;
					TeamPositionX[team][braincount] = brain.Pos.X;
		
					--Brain locating stuff
					self.PlayerBrainPos[player] = brain.Pos.X;
			
					--Add objective points
					if self.Escape then
						self:AddObjectivePoint("Escort!", brain.AboveHUDPos, team, GameActivity.ARROWDOWN);
					else
						self:AddObjectivePoint("Protect!", brain.AboveHUDPos, team, GameActivity.ARROWDOWN);
					end
					for player2 = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
						if player2 ~= player and self:PlayerActive(player2) and self:PlayerHuman(player2) and MovableMan:IsActor(self:GetPlayerBrain(player2)) and self:GetTeamOfPlayer(player2) ~= self:GetTeamOfPlayer(player) then
							local team2 = self:GetTeamOfPlayer(player2);
							self:AddObjectivePoint("Destroy!", self:GetPlayerBrain(player2).AboveHUDPos, team, GameActivity.ARROWDOWN);
						end
					end
					if brain.Pos.Y < 0 then
						brain.ToDelete = true
						self.braindead[player] = true
						if self.Escape == true then
							--Owner wins!
							self.WinnerTeam = self:GetTeamOfPlayer(player)
							ActivityMan:EndActivity()
							--Tell the script to stop running for brains as the game has ended.
							AudioMan:ClearMusicQueue();
							AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/uwinfinal.ogg", -1, -1);
						else
							self.BrainDropDuration[player] = 100
							self.TempBrain[player] = CreateActor("Brain Case");
							self.TempBrain[player].Pos = Vector(brain.Pos.X , 0)
							MovableMan:AddActor(self.TempBrain[player]);
							self:SetPlayerBrain(self.TempBrain[player],player);
							--Make the brain invisible.
							self.TempBrain[player].Scale = 0;
						end
					end
				end
			end
		end
		--Find brain average point for AI for LZ stuff
		local i = braincount
		if braincount > 0 then
			while i > 0 do
				if brainPositionX[i]-brainPositionX[1] > SceneMan.SceneWidth/2 then
					brainPositionX[i] = brainPositionX[i] - SceneMan.SceneWidth;
				else
					if brainPositionX[i]+brainPositionX[1] < SceneMan.SceneWidth/2 then
						brainPositionX[i] = brainPositionX[i] + SceneMan.SceneWidth;
					end
				end
				brainPositionX2 = brainPositionX2+brainPositionX[i];
				i = i - 1
			end
			brainPositionX2 = brainPositionX2/(braincount);
		end
		i = 4
		while i > 0 do
			i = i - 1
			if self.Escape then
				self:AddObjectivePoint("Escape!", Vector(brainPositionX2 , -100), i, GameActivity.ARROWDOWN);
			end
		end
		
		if brainPositionX2 > SceneMan.SceneWidth/2 then
			brainPositionX2 = brainPositionX2 - SceneMan.SceneWidth/2;
		else
			brainPositionX2 = brainPositionX2 + SceneMan.SceneWidth/2;
		end
		if not self.Escape then
			EnemySpawnX1 = brainPositionX2;
			EnemySpawnX2 = brainPositionX2;
		else
			EnemySpawnX1 = brainPositionX2 + SceneMan.SceneWidth/2 - 300;
			EnemySpawnX2 = brainPositionX2 - SceneMan.SceneWidth/2 + 300;
		end
	
		--Find brain average point for each team for LZ stuff
		local i = 0
		while i < 5 do
			local j = Teambraincount[i]
			if Teambraincount[i] > 0 then
				while j > 0 do
					if TeamPositionX[i][j]-TeamPositionX[i][1] > SceneMan.SceneWidth/2 then
						TeamPositionX[i][j] = TeamPositionX[i][j] - SceneMan.SceneWidth;
					else
						if TeamPositionX[i][j]+TeamPositionX[i][1] < SceneMan.SceneWidth/2 then
							TeamPositionX[i][j] = TeamPositionX[i][j] + SceneMan.SceneWidth;
						end
					end
					TeamPositionX2[i] = TeamPositionX2[i]+TeamPositionX[i][j];
					j = j - 1
				end
				TeamPositionX2[i] = TeamPositionX2[i]/(Teambraincount[i]);
			end
			TeamSpawnX1[i] = TeamPositionX2[i];
			TeamSpawnX2[i] = TeamPositionX2[i];
			i = i + 1
		end
		--Spawn the AI.
		if self.CPUTeam == nil then
			self.CPUTeam = Activity.NOTEAM;
			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
				if self:PlayerActive(player) and not(self:PlayerHuman(player)) then
					local team = self:GetTeamOfPlayer(player);
					self.CPUTeam = team;
				end
			end
		end
		self.currentenemies = 0;
		local workingX = 0
		for actor in MovableMan.Actors do
			if (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") then
				workingX = actor.Pos.X;
				if actor.Team == self.CPUTeam then
					self.currentenemies = self.currentenemies + 1;
						if workingX > brainPositionX2 + SceneMan.SceneWidth/2 then
						workingX = workingX-SceneMan.SceneWidth;
					else
						if workingX < brainPositionX2 - SceneMan.SceneWidth/2 then
							workingX = workingX+SceneMan.SceneWidth;
						end
					end
					if workingX > EnemySpawnX1 then
						EnemySpawnX1 = workingX
					end
					if workingX < EnemySpawnX2 then
						EnemySpawnX2 = workingX
					end
				else
					local i = 0
					while i < 5 do
						if actor.Team == i then
								if workingX > TeamPositionX2[i] + SceneMan.SceneWidth/2 then
								workingX = workingX-SceneMan.SceneWidth;
							else
								if workingX < TeamPositionX2[i] - SceneMan.SceneWidth/2 then
									workingX = workingX+SceneMan.SceneWidth;
								end
							end
							local check = true
							for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
								if self:PlayerActive(player) and self:PlayerHuman(player) and MovableMan:IsActor(self:GetPlayerBrain(player)) then
									if actor.ID == self:GetPlayerBrain(player).ID then
										if workingX + 400 > TeamSpawnX1[i] then
											TeamSpawnX1[i] = workingX + 400
										end
										if workingX - 400 < TeamSpawnX2[i] then
											TeamSpawnX2[i] = workingX - 400
										end
										check = false
									end
								end
							end
							if check then
								if workingX > TeamSpawnX1[i] then
									TeamSpawnX1[i] = workingX
								end
								if workingX < TeamSpawnX2[i] then
									TeamSpawnX2[i] = workingX
								end
							end
						end
						i = i + 1
					end
				end
			end
		end
			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				local team = self:GetTeamOfPlayer(player)
				local area = Area()
				local box = Box()
				box.Corner = Vector(TeamSpawnX2[team] , 500)
				box.Height = 1000
				box.Width = TeamSpawnX1[team] - TeamSpawnX2[team]
				area:AddBox(box)
				self:SetLZArea(team, area);
				self:SetBrainLZWidth(team, 0);
			end
		end
		local AIcontrol = (EnemySpawnX1 - EnemySpawnX2)/SceneMan.SceneWidth
		if self.ESpawnTimer:IsPastSimMS(self.wavewaittime+(self.currentenemies * (self.wavewaittime - 5000) * 0.1)) and self.CPUTeam ~= Activity.NOTEAM and MovableMan:GetMOIDCount() <= 210 and self.StopSending < 0 then
			local actor = {};
			for x = 0, math.ceil(math.random(self.maxDeliveryLoad-self.minDeliveryLoad)) + self.minDeliveryLoad do
				local Tech = math.random(0, self.TechElapsed)
				if Tech < 100 - self.TechElapsed * 0.25 then
					actor[x] = CF_SpawnRandomInfantry(self.CPUTeam , nil , CF_Factions[math.random(#CF_Factions)] , Actor.AIMODE_BRAINHUNT);
					actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
				else
					actor[x] = CF_SpawnArmor(self.CPUTeam , nil , CF_Factions[math.random(#CF_Factions)] , Actor.AIMODE_BRAINHUNT);
				end
			end
			local ship = nil;
			if math.random() < (AIcontrol * 4) - 3 then
					ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
				else
					if math.random() < (AIcontrol * 2) - 1 then
						ship = CreateACRocket(self.RocketList[math.random(#self.RocketList)]);
					else
						ship = CreateACDropShip(self.DropShipList[math.random(#self.DropShipList)]);
					end
				end
				for n = 0, #actor do
					ship:AddInventoryItem(actor[n]);
				end
			ship.Team = self.CPUTeam;
			if math.random() < 0.5 then
					if EnemySpawnX1 - brainPositionX2 < SceneMan.SceneWidth*0.25 then
						ship.Pos = Vector(EnemySpawnX1 + math.random(-200, 600),0);
					else
						ship.Pos = Vector(EnemySpawnX1 + math.random(-500, -100) + math.min(600 , self.TechElapsed),0);
					end
				else
					if brainPositionX2 - EnemySpawnX2 < SceneMan.SceneWidth*0.25 then
						ship.Pos = Vector(EnemySpawnX2 + math.random(-600, 200),0);
					else
						ship.Pos = Vector(EnemySpawnX2 + math.random(100, 500) - math.min(600 , self.TechElapsed),0);
					end
				end
			MovableMan:AddActor(ship);
			self.ESpawnTimer:Reset();
		end
		--Win/Lose Conditions
		if self.CPUTeam == Activity.NOTEAM then
			if self.playertally == 1 then
				for i = 1, #self.playerlist do
					if self.playerlist[i] == true then
						self.WinnerTeam = i - 1;
						ActivityMan:EndActivity();
					end
				end
			end
		else
			if self.playertally == 0 then
				self.WinnerTeam = self.CPUTeam;
				ActivityMan:EndActivity();
				AudioMan:ClearMusicQueue();
				AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/udiedfinal.ogg", -1, -1);
			end
		end

		--Special Wave Logic
		if self.timeElapsed >= self.Specialtime then
			local once = false
			if self.SpecialStage == 0 and once == false then
				local enemyAttackAmount = (3 + math.floor(self.timeElapsed * 0.005))*(self.Diff^0.5)
				self.Specialtime = self.Specialtime + 1
				self.SpecialStage = 1
				self.SpecialStageRepeat = enemyAttackAmount
				once = true
			end
				--Browncoat
				if self.SpecialStage == 1 and once == false then
				local actor = nil;
				actor = CreateAHuman("Browncoat Heavy");
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
				actor:AddInventoryItem(CreateHDFirearm(self.AdvancedPrimaryWeaponList[math.random(#self.AdvancedPrimaryWeaponList)]));
				actor:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
	
				local ship = nil;
				ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
				ship:AddInventoryItem(actor);
				ship.Team = self.CPUTeam;
				ship.Pos = Vector(EnemySpawnX2 + math.random(-400, -200),0);
				MovableMan:AddActor(ship);
				if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
					self.Specialtime = self.Specialtime + 1
					self.SpecialStage = 2
					self.SpecialStageRepeat = self.SpecialStageRepeat - 1
				else
					self.Specialtime = self.Specialtime + 15 / (self.Diff^0.5)
					self.SpecialStage = 3
					self.StopSending = 10
				end
				once = true
			end
			if self.SpecialStage == 2 and once == false then
				local actor = nil;
				actor[x] = CF_SpawnArmor(self.CPUTeam , nil , CF_Factions[math.random(#CF_Factions)] , Actor.AIMODE_BRAINHUNT)
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
				actor:AddInventoryItem(CreateHDFirearm(self.AdvancedPrimaryWeaponList[math.random(#self.AdvancedPrimaryWeaponList)]));
				actor:AddInventoryItem(CreateHDFirearm(self.SecondaryWeaponList[math.random(#self.SecondaryWeaponList)]));
				local ship = nil;
				ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
				ship:AddInventoryItem(actor);
				ship.Team = self.CPUTeam;
				ship.Pos = Vector(EnemySpawnX1 + math.random(200, 400),0);
				MovableMan:AddActor(ship);
				if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
					self.Specialtime = self.Specialtime + 1
					self.SpecialStage = 1
					self.SpecialStageRepeat = self.SpecialStageRepeat - 1
				else
					self.Specialtime = self.Specialtime + 15 / (self.Diff^0.5)
					self.SpecialStage = 3
					self.StopSending = 10
				end
				once = true
			end
		
			if self.SpecialStage == 3 and once == false then
				self.TechElapsed = self.TechElapsed / 2
				self.wavewaittime = self.MaxWaveDelay
				self.Specialtime = self.Specialtime + 90 / self.Diff^0.5
				self.SpecialStage = 4
				once = true
			end
			if self.SpecialStage == 4 and once == false then
				local enemyAttackAmount = (3 + math.floor(self.timeElapsed * 0.005))*(self.Diff^0.5)
				self.Specialtime = self.Specialtime + 1
				self.SpecialStage = 5
				self.SpecialStageRepeat = enemyAttackAmount
				once = true
			end
				--Dreadnaught
				if self.SpecialStage == 5 then
				local actor = nil;
				actor[x] = CF_SpawnArmorCrab(self.CPUTeam , nil , CF_Factions[math.random(#CF_Factions)] , Actor.AIMODE_BRAINHUNT)
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
	
				local ship = nil;
				ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
				ship:AddInventoryItem(actor);
				ship.Team = self.CPUTeam;
				ship.Pos = Vector(EnemySpawnX1 + math.random(0, 200),0);
				MovableMan:AddActor(ship);
				if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
					self.Specialtime = self.Specialtime + 1
					self.SpecialStage = 6
					self.SpecialStageRepeat = self.SpecialStageRepeat - 1
				else
					self.Specialtime = self.Specialtime + 90 / (self.Diff^0.5)
					self.wavewaittime = self.MaxWaveDelay
					self.TechElapsed = self.TechElapsed / 2
					self.SpecialStage = 7
					self.StopSending = 10
				end
				once = true
			end
			if self.SpecialStage == 6 and once == false then
				local actor = nil;
				actor[x] = CF_SpawnArmorCrab(self.CPUTeam , nil , CF_Factions[math.random(#CF_Factions)] , Actor.AIMODE_BRAINHUNT)
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
				local ship = nil;
				ship = CreateACRocket(self.PodList[math.random(#self.PodList)]);
				ship:AddInventoryItem(actor);
				ship.Team = self.CPUTeam;
				ship.Pos = Vector(EnemySpawnX2 + math.random(-200, 0),0);
				MovableMan:AddActor(ship);
				if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
					self.Specialtime = self.Specialtime + 1
					self.SpecialStage = 5
					self.SpecialStageRepeat = self.SpecialStageRepeat - 1
				else
					self.Specialtime = self.Specialtime + 90 / (self.Diff^0.5)
					self.wavewaittime = self.MaxWaveDelay
					self.TechElapsed = self.TechElapsed / 2
					self.SpecialStage = 7
					self.StopSending = 10
				end
				once = true
			end
			if self.SpecialStage == 7 and once == false then
				local enemyAttackAmount = 1 + math.floor(self.timeElapsed * 0.01) + 1 * self.Diff^0.5
				self.Specialtime = self.Specialtime + 1
				self.SpecialStage = 8
				self.SpecialStageRepeat = enemyAttackAmount
				once = true
				self.StopSending = 5;
			end
	
				--Assault Coalition
		
			if self.SpecialStage == 8 and once == false then
				local actor = nil;
				actor = CreateAHuman("Coalition Assault");
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
				actor.Pos = Vector(brainPositionX2 + math.random(-800, 800),0);
				MovableMan:AddActor(actor);
				actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun"));
				actor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
				if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
					self.Specialtime = self.Specialtime + 1
					self.SpecialStage = 9
					self.SpecialStageRepeat = self.SpecialStageRepeat - 1
				else
					self.Specialtime = self.Specialtime + 5 / (self.Diff^0.5)
					self.SpecialStage = 10
					self.StopSending = 10
				end
				once = true
			end
			if self.SpecialStage == 9 and once == false then
				local actor = nil;
				actor = CreateAHuman("Coalition Assault");
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
				actor.Pos = Vector(brainPositionX2 + math.random(-800, 800),0);
				MovableMan:AddActor(actor);
				actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun"));
				actor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
				if self.SpecialStageRepeat > 1 and MovableMan:GetMOIDCount() <= 210 then
					self.Specialtime = self.Specialtime + 1
					self.SpecialStage = 8
					self.SpecialStageRepeat = self.SpecialStageRepeat - 1
				else
					self.Specialtime = self.Specialtime + 5 / (self.Diff^0.5)
					self.SpecialStage = 10
					self.StopSending = 10
				end
				once = true
			end
	
	
			if self.SpecialStage == 10 and once == false then
				self.wavewaittime = self.MaxWaveDelay
				self.TechElapsed = self.TechElapsed / 2
				self.Specialtime = self.Specialtime + 90 / (self.Diff^0.5)
				self.SpecialStage = 11
				once = true
			end
			if self.SpecialStage == 11 and once == false then
				self.Specialtime = self.Specialtime + 1
				self.SpecialStage = 12
				once = true
			end
	
				--Apc(removed)
	
			if self.SpecialStage == 12 and once == false then
				self.Specialtime = self.Specialtime + 60
				local check = true
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					if self:PlayerActive(player) and self:PlayerHuman(player) then
						if self:GetPlayerBrain(player).PresetName == "Brain Case" or self:GetPlayerBrain(player).PinStrength <= 0 then
							check = false
							self.SpecialStage = 13
						end
					end
				end
				if check then
					self.SpecialStage = 0
				end
				self.StopSending = 20
				once = true
			end
			if self.SpecialStage == 13 and once == false then
				self.wavewaittime = self.wavewaittime * 0.75
				self.TechElapsed = self.TechElapsed * 2
				self.Specialtime = self.timeElapsed
				self.SpecialStage = 14
				once = true
			end
			if self.SpecialStage == 14 and once == false then
				local check = true
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					if self:PlayerActive(player) and self:PlayerHuman(player) then
						if self.BrainDropDuration[player] > -500 then
							check = false
						end
					end
				end
				if check == true then
					self.SpecialStage = 15
					self.Specialtime = self.timeElapsed + 2.5
				end
				once = true
			end
			if self.SpecialStage == 15 and once == false and self.Escape == false then
				local check = false
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					if self:PlayerActive(player) and self:PlayerHuman(player) then
						if self:GetPlayerBrain(player).PresetName == "Brain Case" then
							check = true
						end
					end
				end
				if check == true then
					self.SpecialStage = 16
					self.Specialtime = self.timeElapsed + 2.5
				else
					self.Escape = true
				end
				once = true
			end
			if self.SpecialStage == 16 and once == false then
				self.SpecialStage = 17
				self.Specialtime = self.Specialtime + 0.2
				once = true
			end
			if self.SpecialStage == 17 and once == false then
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					if self:PlayerActive(player) and self:PlayerHuman(player) then
						local brain = self:GetPlayerBrain(player)
						if brain.PresetName == "Brain Case" then
							local fxa = CreateAEmitter("Brain Detach Sound");
							fxa.Pos = brain.Pos;
							MovableMan:AddParticle(fxa);
						end
					end
				end
				self.SpecialStage = 18
				self.Specialtime = self.Specialtime + 0.1
				once = true
			end
			if self.SpecialStage == 18 and once == false then
				for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
					if self:PlayerActive(player) and self:PlayerHuman(player) then
						local brain = self:GetPlayerBrain(player)
						if brain.PresetName == "Brain Case" then
							local actor = nil;
							actor = CreateAHuman("Brain Robot");
							actor.Team = brain.Team;
							actor.AIMode = Actor.AIMODE_SENTRY;
							actor.RotAngle = math.pi
							actor.Pos = brain.Pos
							MovableMan:AddActor(actor);
							self:SetPlayerBrain(actor,player);
							brain.ToDelete = true
						end
					end
				end
				self.SpecialStage = 19
				self.Specialtime = self.Specialtime + 0.5
				once = true
			end
			if self.SpecialStage == 19 and once == false then
				self.Escape = true
				self.SpecialStage = 20
				once = true
			end
		end
		if self.DoneEditing == false then
			self.DoneEditing = true
			MovableMan:OpenAllDoors(false, Activity.NOTEAM);
			self:DisableAIs(false, Activity.NOTEAM);
			self:InitAIs()
			SceneMan.Scene:ResetPathFinding();
		end
	else
		self.StartTimer:Reset();
		self.DoneEditing = false
		MovableMan:OpenAllDoors(true, Activity.NOTEAM);
		self:DisableAIs(true, Activity.NOTEAM);
	end
end